Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 7041)
@@ -6,7 +6,4 @@
    !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) 
    !!----------------------------------------------------------------------
-#if defined key_cfc
-   !!----------------------------------------------------------------------
-   !!   'key_cfc'                                               CFC tracers
    !!----------------------------------------------------------------------
    !! trc_ini_cfc      : CFC model initialisation
@@ -46,4 +43,5 @@
       INTEGER  ::  iskip = 6   ! number of 1st descriptor lines
       REAL(wp) ::  zyy, zyd
+      CHARACTER(len = 20)  ::  cltra
       !!----------------------------------------------------------------------
 
@@ -52,4 +50,30 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
 
+      
+      ! assign an index in trc arrays for each CFC prognostic variables
+      jp_cfc = 1 
+      IF( ln_cfc11 .AND. ln_cfc12 )  jp_cfc = 2
+
+      ! assign an index in trc arrays for each prognostic variables
+      DO jn = 1, jptra
+        cltra = ctrcnm(jn) 
+        IF( cltra == 'CFC11'  .OR. cltra == 'cfc11' )   jpc11 = jn 
+        IF( cltra == 'CFC12'  .OR. cltra == 'cfc12' )   jpc12 = jn 
+      ENDDO
+   
+      IF( jp_cfc == 1 ) THEN
+        IF( ln_cfc11 )  jp_cfc0  = jpc11
+        IF( ln_cfc12 )  jp_cfc0  = jpc12
+      ELSE
+        jp_cfc0 = MIN( jpc11, jpc12 ) 
+      ENDIF
+      jp_cfc1 = jp_cfc0 + jp_cfc - 1
+
+      IF( lwp ) THEN
+        WRITE(numout,*) ''
+        WRITE(numout,*) ' First index of CFC tracer in the passive tracer array   jp_cfc0 = ', jp_cfc0
+        WRITE(numout,*) ' Last  index of CFC tracer in the passive tracer array   jp_cfc1 = ', jp_cfc1
+        WRITE(numout,*) 
+      ENDIF
 
       IF(lwp) WRITE(numout,*) 'read of formatted file cfc1112atm'
@@ -146,13 +170,4 @@
    END SUBROUTINE trc_ini_cfc
    
-#else
-   !!----------------------------------------------------------------------
-   !!   Dummy module                                         No CFC tracers
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trc_ini_cfc             ! Empty routine
-   END SUBROUTINE trc_ini_cfc
-#endif
-
    !!======================================================================
 END MODULE trcini_cfc
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 7041)
@@ -6,15 +6,9 @@
    !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) from trcnam.cfc.h90
    !!----------------------------------------------------------------------
-#if defined key_cfc
-   !!----------------------------------------------------------------------
-   !!   'key_cfc'                                               CFC tracers
-   !!----------------------------------------------------------------------
    !! trc_nam_cfc      : CFC model initialisation
    !!----------------------------------------------------------------------
    USE oce_trc         ! Ocean variables
-   USE par_trc         ! TOP parameters
    USE trc             ! TOP variables
    USE trcsms_cfc      ! CFC specific variable
-   USE iom             ! I/O manager
 
    IMPLICIT NONE
@@ -42,27 +36,18 @@
       !! ** input   :   Namelist namcfc
       !!----------------------------------------------------------------------
-      INTEGER ::  numnatc_ref = -1   ! Logical unit for reference CFC namelist
-      INTEGER ::  numnatc_cfg = -1   ! Logical unit for configuration CFC namelist
-      INTEGER ::  numonc      = -1   ! Logical unit for output namelist
       INTEGER :: ios                 ! Local integer output status for namelist read
       INTEGER :: jl, jn
-      TYPE(DIAG), DIMENSION(jp_cfc_2d) :: cfcdia2d
       !!
-      NAMELIST/namcfcdate/ ndate_beg, nyear_res
-      NAMELIST/namcfcdia/  cfcdia2d     ! additional diagnostics
+      NAMELIST/namcfc/ ndate_beg, nyear_res
       !!----------------------------------------------------------------------
-      !                             ! Open namelist files
-      CALL ctl_opn( numnatc_ref, 'namelist_cfc_ref'   ,     'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-      CALL ctl_opn( numnatc_cfg, 'namelist_cfc_cfg'   ,     'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-      IF(lwm) CALL ctl_opn( numonc, 'output.namelist.cfc', 'UNKNOWN', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
 
-      REWIND( numnatc_ref )              ! Namelist namcfcdate in reference namelist : CFC parameters
-      READ  ( numnatc_ref, namcfcdate, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdate in reference namelist', lwp )
+      REWIND( numtrc_ref )              ! Namelist namcfcdate in reference namelist : CFC parameters
+      READ  ( numtrc_ref, namcfc, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfc in reference namelist', lwp )
 
-      REWIND( numnatc_cfg )              ! Namelist namcfcdate in configuration namelist : CFC parameters
-      READ  ( numnatc_cfg, namcfcdate, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdate in configuration namelist', lwp )
-      IF(lwm) WRITE ( numonc, namcfcdate )
+      REWIND( numtrc_cfg )              ! Namelist namcfcdate in configuration namelist : CFC parameters
+      READ  ( numtrc_cfg, namcfc, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfc in configuration namelist', lwp )
+      IF(lwm) WRITE ( numonr, namcfc )
 
       IF(lwp) THEN                  ! control print
@@ -76,51 +61,8 @@
       IF(lwp) WRITE(numout,*) '    initial year (aa)                       nyear_beg = ', nyear_beg
       !
-
-      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
-         !
-         ! Namelist namcfcdia
-         ! -------------------
-         REWIND( numnatc_ref )              ! Namelist namcfcdia in reference namelist : CFC diagnostics
-         READ  ( numnatc_ref, namcfcdia, IOSTAT = ios, ERR = 903)
-903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdia in reference namelist', lwp )
-
-         REWIND( numnatc_cfg )              ! Namelist namcfcdia in configuration namelist : CFC diagnostics
-         READ  ( numnatc_cfg, namcfcdia, IOSTAT = ios, ERR = 904 )
-904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdia in configuration namelist', lwp )
-         IF(lwm) WRITE ( numonc, namcfcdia )
-
-         DO jl = 1, jp_cfc_2d
-            jn = jp_cfc0_2d + jl - 1
-            ctrc2d(jn) = TRIM( cfcdia2d(jl)%sname )
-            ctrc2l(jn) = TRIM( cfcdia2d(jl)%lname )
-            ctrc2u(jn) = TRIM( cfcdia2d(jl)%units )
-         END DO
-
-         IF(lwp) THEN                   ! control print
-            WRITE(numout,*)
-            WRITE(numout,*) ' Namelist : natadd'
-            DO jl = 1, jp_cfc_2d
-               jn = jp_cfc0_2d + jl - 1
-               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
-                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
-            END DO
-            WRITE(numout,*) ' '
-         ENDIF
-         !
-      ENDIF
-
-   IF(lwm) CALL FLUSH ( numonc )     ! flush output namelist CFC
+      IF(lwm) CALL FLUSH ( numonr )     ! flush output namelist CFC
 
    END SUBROUTINE trc_nam_cfc
    
-#else
-   !!----------------------------------------------------------------------
-   !!  Dummy module :                                                No CFC
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trc_nam_cfc                      ! Empty routine
-   END  SUBROUTINE  trc_nam_cfc
-#endif  
-
    !!======================================================================
 END MODULE trcnam_cfc
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 7041)
@@ -7,8 +7,4 @@
    !!  NEMO      1.0  !  2004-03  (C. Ethe) free form + modularity
    !!            2.0  !  2007-12  (C. Ethe, G. Madec)  reorganisation
-   !!----------------------------------------------------------------------
-#if defined key_cfc
-   !!----------------------------------------------------------------------
-   !!   'key_cfc'                                               CFC tracers
    !!----------------------------------------------------------------------
    !!   trc_sms_cfc  :  compute and add CFC suface forcing to CFC trends
@@ -159,7 +155,4 @@
                ! trn in pico-mol/l idem qtr; ak in en m/a
                qtr_cfc(ji,jj,jl) = -zak_cfc * ( trb(ji,jj,1,jn) - zca_cfc )   &
-#if defined key_degrad
-                  &                         * facvol(ji,jj,1)                           &
-#endif
                   &                         * tmask(ji,jj,1) * ( 1. - fr_i(ji,jj) )
                ! Add the surface flux to the trend
@@ -185,11 +178,8 @@
       !
       IF( lk_iomput ) THEN
-         CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-         CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
-      ELSE
-         IF( ln_diatrc ) THEN
-            trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
-            trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
-         END IF
+         DO jn = jp_cfc0, jp_cfc1
+            CALL iom_put( 'qtr_'//ctrcnm(jn) , qtr_cfc (:,:,jn) )
+            CALL iom_put( 'qint_'//ctrcnm(jn), qint_cfc(:,:,jn) )
+         ENDDO
       END IF
       !
@@ -277,14 +267,4 @@
    END FUNCTION trc_sms_cfc_alloc
 
-#else
-   !!----------------------------------------------------------------------
-   !!   Dummy module                                         No CFC tracers
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trc_sms_cfc( kt )       ! Empty routine
-      WRITE(*,*) 'trc_sms_cfc: You should not have seen this print! error?', kt
-   END SUBROUTINE trc_sms_cfc
-#endif
-
    !!======================================================================
 END MODULE trcsms_cfc
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcwri_cfc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcwri_cfc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/CFC/trcwri_cfc.F90	(revision 7041)
@@ -6,7 +6,5 @@
    !! History :   1.0  !  2009-05 (C. Ethe)  Original code
    !!----------------------------------------------------------------------
-#if defined key_top && defined key_cfc && defined key_iomput
-   !!----------------------------------------------------------------------
-   !!   'key_cfc'                                           cfc model
+#if defined key_top && defined key_iomput
    !!----------------------------------------------------------------------
    !! trc_wri_cfc   :  outputs of concentration fields
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/par_my_trc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/par_my_trc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/par_my_trc.F90	(revision 7041)
@@ -10,25 +10,6 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-   USE par_pisces , ONLY : jp_pisces       !: number of tracers in PISCES
-   USE par_pisces , ONLY : jp_pisces_2d    !: number of 2D diag in PISCES
-   USE par_pisces , ONLY : jp_pisces_3d    !: number of 3D diag in PISCES
-   USE par_pisces , ONLY : jp_pisces_trd   !: number of biological diag in PISCES
-
-   USE par_cfc    , ONLY : jp_cfc          !: number of tracers in CFC
-   USE par_cfc    , ONLY : jp_cfc_2d       !: number of tracers in CFC
-   USE par_cfc    , ONLY : jp_cfc_3d       !: number of tracers in CFC
-   USE par_cfc    , ONLY : jp_cfc_trd      !: number of tracers in CFC
-
-   USE par_c14b   , ONLY : jp_c14b         !: number of tracers in C14
-   USE par_c14b   , ONLY : jp_c14b_2d      !: number of tracers in C14
-   USE par_c14b   , ONLY : jp_c14b_3d      !: number of tracers in C14
-   USE par_c14b   , ONLY : jp_c14b_trd     !: number of tracers in C14
 
    IMPLICIT NONE
-
-   INTEGER, PARAMETER ::   jp_lm      =  jp_pisces     + jp_cfc     + jp_c14b     !: 
-   INTEGER, PARAMETER ::   jp_lm_2d   =  jp_pisces_2d  + jp_cfc_2d  + jp_c14b_2d  !:
-   INTEGER, PARAMETER ::   jp_lm_3d   =  jp_pisces_3d  + jp_cfc_3d  + jp_c14b_3d  !:
-   INTEGER, PARAMETER ::   jp_lm_trd  =  jp_pisces_trd + jp_cfc_trd + jp_c14b_trd !:
 
 #if defined key_my_trc
@@ -36,12 +17,6 @@
    !!   'key_my_trc'                     user defined tracers (MY_TRC)
    !!---------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_my_trc     = .TRUE.   !: PTS flag 
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc     =  1       !: number of PTS tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_2d  =  0       !: additional 2d output arrays ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_3d  =  0       !: additional 3d output arrays ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_trd =  0       !: number of sms trends for MY_TRC
-
-   ! assign an index in trc arrays for each PTS prognostic variables
-   INTEGER, PUBLIC, PARAMETER ::   jpmyt1 = jp_lm + 1     !: 1st MY_TRC tracer
+   LOGICAL, PUBLIC, PARAMETER ::   lk_my_trc  = .TRUE.   !: PTS flag 
+   INTEGER, PUBLIC            ::   jp_my_trc      !: number of PTS tracers
 
 #else
@@ -49,21 +24,13 @@
    !!   Default                           No user defined tracers (MY_TRC)
    !!---------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_my_trc     = .FALSE.  !: MY_TRC flag 
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc     =  0       !: No MY_TRC tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_2d  =  0       !: No MY_TRC additional 2d output arrays 
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_3d  =  0       !: No MY_TRC additional 3d output arrays 
-   INTEGER, PUBLIC, PARAMETER ::   jp_my_trc_trd =  0       !: number of sms trends for MY_TRC
+   LOGICAL, PUBLIC, PARAMETER ::   lk_my_trc   = .FALSE.  !: MY_TRC flag 
+   INTEGER, PUBLIC            ::   jp_my_trc        !: No MY_TRC tracers
 #endif
 
    ! Starting/ending PISCES do-loop indices (N.B. no PISCES : jpl_pcs < jpf_pcs the do-loop are never done)
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt0     = jp_lm     + 1              !: First index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt1     = jp_lm     + jp_my_trc      !: Last  index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt0_2d  = jp_lm_2d  + 1              !: First index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt1_2d  = jp_lm_2d  + jp_my_trc_2d   !: Last  index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt0_3d  = jp_lm_3d  + 1              !: First index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt1_3d  = jp_lm_3d  + jp_my_trc_3d   !: Last  index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt0_trd = jp_lm_trd + 1              !: First index of MY_TRC passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_myt1_trd = jp_lm_trd + jp_my_trc_trd  !: Last  index of MY_TRC passive tracers
+   INTEGER, PUBLIC ::   jp_myt0             !: First index of MY_TRC passive tracers
+   INTEGER, PUBLIC ::   jp_myt1             !: Last  index of MY_TRC passive tracers
 
+   INTEGER, PUBLIC ::   jpmyt0, jpmty1, jpmyt2         !: Last  index of MY_TRC passive tracers
    !!======================================================================
 END MODULE par_my_trc
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 7041)
@@ -37,4 +37,32 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
+      INTEGER              ::  jn
+      CHARACTER(len = 20)  ::  cltra
+
+
+      jp_my_trc = 1
+      ! assign an index in trc arrays for each prognostic variables
+      DO jn = 1, jptra
+        cltra = ctrcnm(jn) 
+        IF( cltra == 'MYTRC'   .OR. cltra == 'mytrc'  )   jpmyt0 = jn 
+        IF( cltra == 'MYTRC1'  .OR. cltra == 'mytrc1' )   jpmyt1 = jn 
+        IF( cltra == 'MYTRC2'  .OR. cltra == 'mytrc2' )   jpmyt2 = jn 
+      ENDDO
+   
+      IF( jp_my_trc == 1 ) THEN
+        jp_myt0  = jpmyt0
+      ELSE
+        jp_myt0 = MIN( jpmyt0, jpmyt1, jpmyt2 ) 
+      ENDIF
+      jp_myt1 = jp_myt0 + jp_my_trc - 1
+
+
+      IF( lwp ) THEN
+        WRITE(numout,*) ''
+        WRITE(numout,*) ' First index of MYTRC model in the passive tracer array   jp_myt0 = ', jp_myt0
+        WRITE(numout,*) ' Last  index of MYTRC model in the passive tracer array   jp_myt1 = ', jp_myt1
+        WRITE(numout,*) 
+      ENDIF
+
 
       !                       ! Allocate MY_TRC arrays
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7041)
@@ -9,7 +9,7 @@
    !!             2.0  !  2007-12  (C. Deltel, G. Madec)  F90
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
+#if defined key_pisces
    !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
+   !!   'key_pisces'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_bio        :  
@@ -86,6 +86,4 @@
       !!                                  source      sink
       !!        
-      !!              IF 'key_diabio' defined , the biogeochemical trends
-      !!              for passive tracers are saved for futher diagnostics.
       !!---------------------------------------------------------------------
       !!
@@ -109,5 +107,5 @@
       IF( nn_timing == 1 )  CALL timing_start('p2z_bio')
       !
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          CALL wrk_alloc( jpi, jpj,     17, zw2d )
          CALL wrk_alloc( jpi, jpj, jpk, 3, zw3d )
@@ -121,5 +119,5 @@
 
       xksi(:,:) = 0.e0        ! zooplakton closure ( fbod)
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          zw2d  (:,:,:) = 0.e0
          zw3d(:,:,:,:) = 0.e0
@@ -218,25 +216,5 @@
                tra(ji,jj,jk,jpdom) = tra(ji,jj,jk,jpdom) + zdoma
 
-
-               IF( ( ln_diabio .AND. .NOT. lk_iomput ) .OR. l_trdtrc ) THEN
-                  trbio(ji,jj,jk,jp_pcs0_trd     ) = zno3phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  1) = znh4phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  2) = zphynh4
-                  trbio(ji,jj,jk,jp_pcs0_trd +  3) = zphydom
-                  trbio(ji,jj,jk,jp_pcs0_trd +  4) = zphyzoo
-                  trbio(ji,jj,jk,jp_pcs0_trd +  5) = zphydet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  6) = zdetzoo
-                  !  trend number 8 in p2zsed
-                  trbio(ji,jj,jk,jp_pcs0_trd +  8) = zzoodet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  9) = zzoobod
-                  trbio(ji,jj,jk,jp_pcs0_trd + 10) = zzoonh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 11) = zzoodom
-                  trbio(ji,jj,jk,jp_pcs0_trd + 12) = znh4no3
-                  trbio(ji,jj,jk,jp_pcs0_trd + 13) = zdomnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 14) = zdetnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 15) = zdetdom
-                  !  trend number 17 in p2zexp
-                ENDIF
-                IF( ln_diatrc .OR. lk_iomput ) THEN
+                IF( lk_iomput ) THEN
                   ! convert fluxes in per day
                   ze3t = e3t_n(ji,jj,jk) * 86400._wp
@@ -340,24 +318,5 @@
                tra(ji,jj,jk,jpdom) = tra(ji,jj,jk,jpdom) + zdoma
                !
-               IF( ( ln_diabio .AND. .NOT. lk_iomput ) .OR. l_trdtrc ) THEN
-                  trbio(ji,jj,jk,jp_pcs0_trd     ) = zno3phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  1) = znh4phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  2) = zphynh4
-                  trbio(ji,jj,jk,jp_pcs0_trd +  3) = zphydom
-                  trbio(ji,jj,jk,jp_pcs0_trd +  4) = zphyzoo
-                  trbio(ji,jj,jk,jp_pcs0_trd +  5) = zphydet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  6) = zdetzoo
-                  !  trend number 8 in p2zsed
-                  trbio(ji,jj,jk,jp_pcs0_trd +  8) = zzoodet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  9) = zzoobod
-                  trbio(ji,jj,jk,jp_pcs0_trd + 10) = zzoonh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 11) = zzoodom
-                  trbio(ji,jj,jk,jp_pcs0_trd + 12) = znh4no3
-                  trbio(ji,jj,jk,jp_pcs0_trd + 13) = zdomnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 14) = zdetnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 15) = zdetdom
-                  !  trend number 17 in p2zexp 
-                ENDIF
-                IF( ln_diatrc .OR. lk_iomput ) THEN
+                IF( lk_iomput ) THEN
                   ! convert fluxes in per day
                   ze3t = e3t_n(ji,jj,jk) * 86400._wp
@@ -389,5 +348,5 @@
       END DO
 
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          DO jl = 1, 17 
             CALL lbc_lnk( zw2d(:,:,jl),'T', 1. )
@@ -420,43 +379,4 @@
         CALL iom_put( "FNH4NO3", zw3d(:,:,:,3) )
          !
-       ELSE
-          IF( ln_diatrc ) THEN
-            !
-            trc2d(:,:,jp_pcs0_2d    ) = zw2d(:,:,1) 
-            trc2d(:,:,jp_pcs0_2d + 1) = zw2d(:,:,2) 
-            trc2d(:,:,jp_pcs0_2d + 2) = zw2d(:,:,3) 
-            trc2d(:,:,jp_pcs0_2d + 3) = zw2d(:,:,4) 
-            trc2d(:,:,jp_pcs0_2d + 4) = zw2d(:,:,5) 
-            trc2d(:,:,jp_pcs0_2d + 5) = zw2d(:,:,6) 
-            trc2d(:,:,jp_pcs0_2d + 6) = zw2d(:,:,7) 
-                     ! trend number 8 is in p2zsed.F
-            trc2d(:,:,jp_pcs0_2d +  8) = zw2d(:,:,8) 
-            trc2d(:,:,jp_pcs0_2d +  9) = zw2d(:,:,9) 
-            trc2d(:,:,jp_pcs0_2d + 10) = zw2d(:,:,10) 
-            trc2d(:,:,jp_pcs0_2d + 11) = zw2d(:,:,11) 
-            trc2d(:,:,jp_pcs0_2d + 12) = zw2d(:,:,12) 
-            trc2d(:,:,jp_pcs0_2d + 13) = zw2d(:,:,13) 
-            trc2d(:,:,jp_pcs0_2d + 14) = zw2d(:,:,14) 
-            trc2d(:,:,jp_pcs0_2d + 15) = zw2d(:,:,15) 
-            trc2d(:,:,jp_pcs0_2d + 16) = zw2d(:,:,16) 
-            trc2d(:,:,jp_pcs0_2d + 17) = zw2d(:,:,17) 
-            ! trend number 19 is in p2zexp.F
-            trc3d(:,:,:,jp_pcs0_3d    ) = zw3d(:,:,:,1) 
-            trc3d(:,:,:,jp_pcs0_3d + 1) = zw3d(:,:,:,2) 
-            trc3d(:,:,:,jp_pcs0_3d + 2) = zw3d(:,:,:,3) 
-         ENDIF
-        !
-      ENDIF
-
-      IF( ln_diabio .AND. .NOT. lk_iomput )  THEN
-         DO jl = jp_pcs0_trd, jp_pcs1_trd
-            CALL lbc_lnk( trbio(:,:,1,jl),'T', 1. )
-         END DO 
-      ENDIF
-      !
-      IF( l_trdtrc ) THEN
-         DO jl = jp_pcs0_trd, jp_pcs1_trd
-            CALL trd_trc( trbio(:,:,:,jl), jl, kt )   ! handle the trend
-         END DO
       ENDIF
 
@@ -467,5 +387,5 @@
       ENDIF
       !
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          CALL wrk_dealloc( jpi, jpj,     17, zw2d )
          CALL wrk_dealloc( jpi, jpj, jpk, 3, zw3d )
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7041)
@@ -10,7 +10,7 @@
    !!             3.5  !  2012-03  (C. Ethe)  Merge PISCES-LOBSTER
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
+#if defined key_pisces
+   !!----------------------------------------------------------------------
+   !!   'key_pisces'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_exp        :  Compute loss of organic matter in the sediments
@@ -68,5 +68,4 @@
       INTEGER  ::   ji, jj, jk, jl, ikt
       REAL(wp) ::   zgeolpoc, zfact, zwork, ze3t, zsedpocd, zmaskt
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrbio
       REAL(wp), POINTER, DIMENSION(:,:)   ::  zsedpoca
       CHARACTER (len=25) :: charout
@@ -80,8 +79,4 @@
       zsedpoca(:,:) = 0.
 
-      IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, ztrbio )   ! temporary save of trends
-         ztrbio(:,:,:) = tra(:,:,:,jpno3)
-      ENDIF
 
       ! VERTICAL DISTRIBUTION OF NEWLY PRODUCED BIOGENIC
@@ -126,9 +121,5 @@
  
       ! Oa & Ek: diagnostics depending on jpdia2d !          left as example
-      IF( lk_iomput ) THEN  
-         CALL iom_put( "SEDPOC" , sedpocn )
-      ELSE
-         IF( ln_diatrc )           trc2d(:,:,jp_pcs0_2d + 18) = sedpocn(:,:)
-      ENDIF
+      IF( lk_iomput )  CALL iom_put( "SEDPOC" , sedpocn )
 
       
@@ -160,11 +151,4 @@
       ENDIF
       !
-      IF( l_trdtrc ) THEN
-         ztrbio(:,:,:) = tra(:,:,:,jpno3) - ztrbio(:,:,:)
-         jl = jp_pcs0_trd + 16
-         CALL trd_trc( ztrbio, jl, kt )   ! handle the trend
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrbio )   ! temporary save of trends
-      ENDIF
-      !
       CALL wrk_dealloc( jpi, jpj, zsedpoca)   ! temporary save of trends
 
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7041)
@@ -11,7 +11,7 @@
    !!             3.2  !  2009-04  (C. Ethe, G. Madec)  minor optimisation + style
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
+#if defined key_pisces
+   !!----------------------------------------------------------------------
+   !!   'key_pisces'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_opt        :   Compute the light availability in the water column
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7041)
@@ -8,7 +8,7 @@
    !!             2.0  !  2007-12  (C. Deltel, G. Madec)  F90 + simplifications
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
+#if defined key_pisces
    !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
+   !!   'key_pisces'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_sed        :  Compute loss of organic matter in the sediments
@@ -66,5 +66,5 @@
       CHARACTER (len=25) :: charout
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra, ztrbio
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra
       !!---------------------------------------------------------------------
       !
@@ -79,8 +79,4 @@
       ! Allocate temporary workspace
       CALL wrk_alloc( jpi, jpj, jpk, zwork, ztra )
-      IF( l_trdtrc ) THEN
-         CALL wrk_alloc( jpi, jpj, jpk, ztrbio )
-         ztrbio(:,:,:) = tra(:,:,:,jpdet)
-      ENDIF
 
       ! sedimentation of detritus  : upstream scheme
@@ -116,25 +112,8 @@
             CALL wrk_dealloc( jpi, jpj, zw2d )
          ENDIF
-      ELSE
-         IF( ln_diatrc ) THEN 
-            CALL wrk_alloc( jpi, jpj, zw2d )
-            zw2d(:,:) =  ztra(:,:,1) * e3t_n(:,:,1) * 86400._wp
-            DO jk = 2, jpkm1
-               zw2d(:,:) = zw2d(:,:) + ztra(:,:,jk) * e3t_n(:,:,jk) * 86400._wp
-            END DO
-            trc2d(:,:,jp_pcs0_2d + 7) = zw2d(:,:)
-            CALL wrk_dealloc( jpi, jpj, zw2d )
-         ENDIF
       ENDIF
       !
-      IF( ln_diabio .AND. .NOT. lk_iomput )  trbio(:,:,:,jp_pcs0_trd + 7) = ztra(:,:,:)
       CALL wrk_dealloc( jpi, jpj, jpk, zwork, ztra )
       !
-      IF( l_trdtrc ) THEN
-         ztrbio(:,:,:) = tra(:,:,:,jpdet) - ztrbio(:,:,:)
-         jl = jp_pcs0_trd + 7
-         CALL trd_trc( ztrbio, jl, kt )   ! handle the trend
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrbio )
-      ENDIF
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7040)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7041)
@@ -7,7 +7,7 @@
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
+#if defined key_pisces
    !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                              LOBSTER bio-model
+   !!   'key_pisces'                              LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2zsms        :  Time loop of passive tracers sms
